unit P_SQLorder;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TForm_SQLorder = class(TForm)
    Label1: TLabel;
    btn_Cancel: TBitBtn;
    Label2: TLabel;
    rbtnAsc: TRadioButton;
    rbtnDesc: TRadioButton;
    lbxName: TListBox;
    btn_Add: TBitBtn;
    btn_Remove: TBitBtn;
    lbxField: TListBox;
    btn_UP: TSpeedButton;
    btn_Down: TSpeedButton;
    BitBtn1: TBitBtn;
    OpenDialog1: TOpenDialog;
    BitBtn2: TBitBtn;
    btn_Run: TBitBtn;
    SaveDialog1: TSaveDialog;
    Label3: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btn_AddClick(Sender: TObject);
    procedure btn_CancelClick(Sender: TObject);
    procedure btn_RemoveClick(Sender: TObject);
    procedure btn_RunClick(Sender: TObject);
    procedure lbxNameDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure lbxNameDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure btn_UPClick(Sender: TObject);
    procedure btn_DownClick(Sender: TObject);
    procedure lbxFieldClick(Sender: TObject);
    procedure lbxNameClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
    nSQLorder: string;
    procedure AddSQL;
    
  public
    { Public declarations }
  end;

var
  Form_SQLorder: TForm_SQLorder;

implementation

uses P_DataBase;

{$R *.DFM}

procedure TForm_SQLorder.AddSQL;
          var FieldIndex: integer;
begin
     FieldIndex:= lbxField.ItemIndex;
     if (FieldIndex=-1) then begin
        Application.MessageBox('пܤ@ӥTW','~',MB_ICONERROR+MB_OK);
        lbxField.SetFocus;
        exit;
     end;

     if rbtnAsc.Checked then
        lbxName.Items.Add(lbxField.Items.Strings[FieldIndex]+' asc')
     else lbxName.Items.Add(lbxField.Items.Strings[FieldIndex]+' desc');
end;

procedure TForm_SQLorder.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
     Action:= caFree;
     Form_SQLorder:= nil;
end;

procedure TForm_SQLorder.FormCreate(Sender: TObject);
          var i: integer;
begin
     for i:= 0 to aQueryCount-1 do lbxField.Items.Add(aftAry[i].fdfieldName);
end;

procedure TForm_SQLorder.FormActivate(Sender: TObject);
begin
     lbxField.SetFocus;
end;

procedure TForm_SQLorder.btn_AddClick(Sender: TObject);
begin
     Form_SQLorder.AddSQL;
end;

procedure TForm_SQLorder.btn_CancelClick(Sender: TObject);
begin
     Form_SQLorder.Close;
end;

procedure TForm_SQLorder.btn_RemoveClick(Sender: TObject);
          var nameNo: integer;
begin
     nameNo:= lbxName.ItemIndex;
     if nameNo=-1 then exit;
     lbxName.Items.Delete(nameNo);
     lbxName.Update;
     dec(nameNo);
     lbxName.ItemIndex:= nameNo;
     btn_ReMove.Enabled:= lbxName.Items.Count > 0;
end;

procedure TForm_SQLorder.btn_RunClick(Sender: TObject);
          var i: integer;
begin
     if lbxName.Items.Count>0 then begin
        nSQLorder:= ' order by ';
        for i:= 0 to lbxName.Items.Count-1 do begin
            if i < lbxName.Items.Count-1 then nSQLorder:= nSQLorder+
                                                          lbxName.Items.Strings[i]+', '
            else nSQLorder:= nSQLorder+lbxName.Items.Strings[i];
        end;
        SQLorder:= nSQLorder;
     end;
     Form_SQLorder.Close;
end;

procedure TForm_SQLorder.lbxNameDragDrop(Sender, Source: TObject; X,
  Y: Integer);
     var aPoint: TPoint;
     Index1, Index2: integer;
begin
     aPoint.x:= X;
     aPoint.y:= Y;
     Index1:= lbxName.ItemAtPos(aPoint,True);
     Index2:= lbxName.ItemIndex;
     lbxName.Items.Insert(Index1,lbxName.Items[Index2]);
     lbxName.Items.Delete(lbxName.ItemIndex);
end;

procedure TForm_SQLorder.lbxNameDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
     Accept:= Source is TListBox;
end;

procedure TForm_SQLorder.btn_UPClick(Sender: TObject);
          var Index1, Index2: integer;
begin
     Index1:= lbxName.ItemIndex;
     Index2:= lbxName.ItemIndex-1;
     if Index2 < 0 then Index2:= 0;
     lbxName.Items.Move(Index1,Index2);
     lbxName.ItemIndex:= index2;
end;

procedure TForm_SQLorder.btn_DownClick(Sender: TObject);
          var Index1, Index2: integer;
begin
     Index1:= lbxName.ItemIndex;
     Index2:= lbxName.ItemIndex+1;
     if Index2 > lbxName.Items.Count-1 then Index2:= lbxName.Items.Count-1;
     lbxname.Items.Move(Index1,Index2);
     lbxName.ItemIndex:= index2;     
end;

procedure TForm_SQLorder.lbxFieldClick(Sender: TObject);
begin
     // P_O_wg[JƧ, ph
     // fieldNo:= lbxField.ItemIndex;
     // if lbxName.Items.IndexOf(lbxField.Items[fieldNo]) <> -1 then btn_Add.Enabled:= False
     // else btn_Add.Enabled:= True;
     // ps: ѩ䪺ListBoxe@P, G indexof Lkoį
     
     btn_Add.Enabled:= True;
     btn_ReMove.Enabled:= False;
     lbxName.ItemIndex:= -1;
end;

procedure TForm_SQLorder.lbxNameClick(Sender: TObject);
begin
     btn_Add.Enabled:= False;
     btn_ReMove.Enabled:= True;
     lbxField.ItemIndex:= -1;
end;

procedure TForm_SQLorder.BitBtn1Click(Sender: TObject);
          var sqlfile: string;
begin
     // ŪJW]w
     if OpenDialog1.Execute then begin
        sqlfile:= OpenDialog1.FileName;
        lbxName.Items.LoadFromFile(sqlfile);
     end;
end;

procedure TForm_SQLorder.BitBtn2Click(Sender: TObject);
          var sqlfile: string;
begin
     if SaveDialog1.Execute then begin
        sqlfile:= SaveDialog1.FileName;
        lbxName.Items.SaveToFile(sqlfile);
     end;
end;

end.
